#include <string.h>
#include <sys/types.h> 
#include <netdb.h>
#include <netinet/in.h>
#include <stdio.h>

#define AF_INET 2       /* from /usr/include/sys/socket.h */

extern int h_errno;     /* values 1 to 4 */

/*
 *  Get network name from ip addr from nameserver
 */
int findnetname(name, addr) 
     char *name, *addr;
{
  struct hostent *host;        /* from netdb.h */
  struct in_addr inaddr;       /* from netinet.h */
  inaddr.s_addr = inet_addr(addr);
  host = gethostbyaddr(&inaddr, sizeof(inaddr), AF_INET);
  if (host == NULL) {
    *name = '\0';
    return(-h_errno);
  }
  strcpy(name, host->h_name);
  return(0);
}

int findnetaddr(name, addr)
     char *name, *addr;
{
  struct in_addr inaddr;         /* from netinet/in.h */
  struct hostent *host;          /* from netdb.h */
  host = gethostbyname(name);
  if (host == NULL) {
    *addr = '\0';
    return(-h_errno);
  }
  bcopy(host->h_addr, (char *)&inaddr, host->h_length);
  strcpy(addr, inet_ntoa(inaddr));
  return(0);
}
